#
#  BUILTINS.MAK Makefile for dBASE Compiler for DOS v1.0
#  (c) Copyright 1992 Borland International Inc.
#
#  --------------------------------------------------------------------------
#  Search order of dBASE extensions used by the dBASE Compiler for DOS.
.suffixes: .prg .dbo .fmt .fmo .frg .fro .lbg .lbo \
           .qbe .qbo .upd .upo .asm .bin .exe

#  --------------------------------------------------------------------------
#  Define macros for Compiler (BDC.EXE), Linker (BDL.EXE) and Assembler
#  (TASM.EXE and TLINK.EXE) for LOAD and CALL binary files.
ASM = TASM
DBCOMP = BDC
DBLINK = BDL
LINK = TLINK

#  --------------------------------------------------------------------------
#  NOTE: Other macros used in this file, AFLAGS, CFLAGS, DFLAGS and TFLAGS,
#        (options for the assembler, dBASE compiler/linker, and TLINK) can 
#        be defined in your .mak file or using MAKE's command line.
#
#        Refer to the MAKE section of the manual for more on macros.

#  --------------------------------------------------------------------------
#  Define our implicit rules for compiling dBASE source files.
#  File types are:
#        Program Files        (.prg)  ==>  (.dbo)
#        Format Files         (.fmt)  ==>  (.fmo)
#        Report Forms         (.frg)  ==>  (.fro)
#        Label Forms          (.lbg)  ==>  (.lbo)
#        Query Files          (.qbe)  ==>  (.qbo)
#        Update Query files   (.upd)  ==>  (.upo)
.dbo.exe:
      $(DBLINK) -E$@ $(DFLAGS) $**

.prg.dbo:
      $(DBCOMP) -c $(CFLAGS) {$< }

.fmt.fmo:
      $(DBCOMP) -c $(CFLAGS) {$< }

.frg.fro:
      $(DBCOMP) -c $(CFLAGS) {$< }

.lbg.lbo:
      $(DBCOMP) -c $(CFLAGS) {$< }

.qbe.qbo:
      $(DBCOMP) -c $(CFLAGS) {$< }

.upd.upo:
      $(DBCOMP) -c $(CFLAGS) {$< }

#  --------------------------------------------------------------------------
#  Use Borland's Assembler for dBASE LOAD and CALL routines.  Refer to the
#  dBASE Compiler Language Reference manual for more on the LOAD and CALL
#  commands and the use of assembled binary files in dBASE.  Also refer to
#  Borland's Assembler manual for more on assembly language, TASM and TLINK.
#  Refer to the DOS manual for more on EXE2BIN.
.asm.bin:
      $(ASM) $(AFLAGS) $<
      $(LINK) $(TFLAGS) $&.obj, $&.exe
      EXE2BIN $&.exe $&.bin

